//+------------------------------------------------------------------+
//|                                                      BDV.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#property copyright "Copyright 2015"
#property link      ""
#property version   "1.00"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 3
#property indicator_level1 0


extern int Periods   = 20;
extern int StartBar  = 1;
extern int RangeBars = 10;

double PercentVariation[], SimpleVariaton[],AverageSD[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
IndicatorBuffers(3);

SetIndexBuffer(0,PercentVariation);
SetIndexStyle (0,DRAW_LINE);
SetIndexBuffer(1,AverageSD);
SetIndexBuffer(2,SimpleVariaton);
   
//---
   return(INIT_SUCCEEDED);
  }

int start()
{
int limit;
int counted_bars=IndicatorCounted();
if (counted_bars>0) counted_bars--;
limit = Bars-counted_bars;

//average stddev 
//differrence std dev- average
for (int i =0; i < limit; i++)
{
   
   double sumSDev; int cont;
   for (int y = StartBar; y <= RangeBars; y ++)
      {
         sumSDev += iStdDev(Symbol(),0,Periods,0,MODE_SMA,PRICE_CLOSE,i+y);
         cont++;
      }
   
   if (cont == 0) cont = 1;
   AverageSD[i]=sumSDev/cont;
   
   SimpleVariaton[i]=iStdDev(Symbol(),0,Periods,0,MODE_SMA,PRICE_CLOSE,i)-AverageSD[i];
   
   if(AverageSD[i]!=0) 
     PercentVariation[i] = SimpleVariaton[i]/AverageSD[i]*100;
   else
     PercentVariation[i]=0;
}


return(0);



}